// IDA.idc
//
//    TTreeView
//
// 20.05.2005

#include <idc.idc>
#include <D:\Programs\IDAidc\DelphiStructure.idc>
#include <D:\Programs\IDAidc\DelphiWinControl.idc>

//****************************************************************************************
//* TTreeNode
//****************************************************************************************

static Struct_TTreeNode()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TTreeNode";
	STRUCTURE_PARENT = "TPersistent_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TObject();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x4);
	AddStrucMember(sHandle, "FOwner",		0x04, FF_DWRD | FF_0OFF, -1, 4);
	AddStrucMember(sHandle, "FText",		0x08, FF_DWRD | FF_0OFF, -1, 4);
	AddStrucMember(sHandle, "FData",		0x0C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"10",		0x10, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FImageIndex",		0x14, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FSelectedIndex",	0x18, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FOverlayIndex",	0x1C, FF_DWRD | FF_0OFF, -1, 4);
	AddStrucMember(sHandle, "FStateIndex",		0x20, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FDeleted",		0x24, FF_BYTE, -1, 1);
	AddStrucMember(sHandle, "FInTree",		0x25, FF_BYTE, -1, 1);
	AddStrucMember(sHandle, NAME+"26",		0x26, FF_BYTE, -1, 1);
	AddStrucMember(sHandle, NAME+"27",		0x27, FF_BYTE, -1, 1);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_0", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_4", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_8", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_C", Address, -1);	}
	return sHandle;
}

//****************************************************************************************
//* TTreeNodes
//****************************************************************************************

static Struct_TTreeNodes()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TTreeNodes";
	STRUCTURE_PARENT = "TPersistent_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TObject();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x4);
	AddStrucMember(sHandle, "FOwner",		0x04, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"8",		0x08, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"C",		0x0C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"10",		0x10, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"14",		0x14, FF_DWRD, -1, 4);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_0", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_4", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_8", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_C", Address, -1);	}
	return sHandle;
}

//****************************************************************************************
//* TCustomTreeViev
//****************************************************************************************

static Struct_TCustomTreeView()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TCustomTreeView";
	STRUCTURE_PARENT = "TWinControl_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TObject();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x204);
	AddStrucMember(sHandle, NAME+"208",		0x208, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"20C",		0x20C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"210",		0x210, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"214",		0x214, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"218",		0x218, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"21C",		0x21C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"220",		0x220, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"224",		0x224, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"228",		0x228, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"22C",		0x22C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"230",		0x230, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"234",		0x234, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"238",		0x238, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"23C",		0x23C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"240",		0x240, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"244",		0x244, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"248",		0x248, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"24C",		0x24C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"250",		0x250, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"254",		0x254, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"258",		0x258, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"25C",		0x25C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"260",		0x260, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"264",		0x264, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"268",		0x268, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"26C",		0x26C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"270",		0x270, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"274",		0x274, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"278",		0x278, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"27C",		0x27C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"280",		0x280, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"284",		0x284, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"288",		0x288, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"28C",		0x28C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"290",		0x290, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"294",		0x294, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"298",		0x298, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"29C",		0x29C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2A0",		0x2A0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2A4",		0x2A4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2A8",		0x2A8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2AC",		0x2AC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2B0",		0x2B0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2B4",		0x2B4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2B8",		0x2B8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2BC",		0x2BC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2C0",		0x2C0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2C4",		0x2C4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2C8",		0x2C8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2CC",		0x2CC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2D0",		0x2D0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2D4",		0x2D4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2D8",		0x2D8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2DC",		0x2DC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2E0",		0x2E0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2E4",		0x2E4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2E8",		0x2E8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2EC",		0x2EC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2F0",		0x2F0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2F4",		0x2F4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2F8",		0x2F8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2FC",		0x2FC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"300",		0x300, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"304",		0x304, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"308",		0x308, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"30C",		0x30C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"310",		0x310, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"314",		0x314, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"318",		0x318, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"31C",		0x31C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"320",		0x320, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"324",		0x324, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"328",		0x328, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"32C",		0x32C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"330",		0x330, FF_DWRD, -1, 4);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_0", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_4", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_8", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_C", Address, -1);	}
	return sHandle;
}

//****************************************************************************************
//* TTreeViev
//****************************************************************************************

static Struct_TTreeView()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TTreeView";
	STRUCTURE_PARENT = "TCustomTreeView_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TObject();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x334);
	AddStrucMember(sHandle, NAME+"334",		0x334, FF_DWRD, -1, 4);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_0", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_4", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_8", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_C", Address, -1);	}
	return sHandle;
}
static main()
{
	Struct_TTreeNode();
	Struct_TTreeNodes();
	Struct_TCustomTreeView();
	Struct_TTreeView();
}
